BINDING_HEADER_CCHEADER = CASHCOUNTER_TITLE;
BINDING_NAME_SHOWHIDE = CASHCOUNTER_SHOWHIDE;
BINDING_NAME_ENABLE = CASHCOUNTER_ENABLEDISABLE;

CC_Vars = {
	visible = true,
	expanded = true,
	above = false,
	enabled = true,
	alpha = 0.4,
	messages = true,
	reset = false,
	askreset = true,
	total = 0,
	current = 0,
	gained = 0,
	lost = 0,
	topString = 1,
	combat = false
};

CC_Strings = {
	current = "",
	total = "",
	gained = "",
	lost = ""
};

tmpvis = false;
before_combat = false;

function CC_OnLoad(self)
	SLASH_CASHCOUNTER1 = "/cashcounter";
	SLASH_CASHCOUNTER2 = "/cc";
	SlashCmdList["CASHCOUNTER"] = CC_SlashCommand;
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_MONEY");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:EnableMouseWheel(true);
end

function CC_SlashCommand(msg)
	msg = string.lower(msg);
	local args = {};
	for word in string.gmatch(msg, "[^%s]+") do
		table.insert(args, word);
	end
	if (args[1] == nil) then args[1] = "help"; end
	if (args[1]) then
		if (args[1] == "enable") then
			CC_Enable();
			
		elseif (args[1] == "disable") then
			CC_Disable();
			
		elseif (args[1] == "show") then
			CC_Show();
			
		elseif (args[1] == "hide") then
			CC_Hide();
			
		elseif (args[1] == "toggle") then
			CC_Visibility();
			
		elseif (args[1] == "options" or args[1] == "config") then
			CC_Options:Show();
			
		elseif (args[1] == "expand") then
			if (args[2] == "down") then
				CC_Vars.above = false;
				CC_Message(CASHCOUNTER_ANCHOR_BELOW);
			elseif (args[2] == "up") then
				CC_Vars.above = true;
				CC_Message(CASHCOUNTER_ANCHOR_ABOVE);
			else
				CC_Message(CASHCOUNTER_NOCOMMAND);
			end
			setAnchor();

		elseif (args[1] == "alpha") then
			local alpha = tonumber(args[2])
			if (alpha and alpha >= 0 and alpha <= 1) then
				CC_Vars.alpha = alpha;
				setAlpha(alpha);
			else
				CC_Message(CASHCOUNTER_ALPHAWRONG);
			end
			
		elseif (args[1] == "msgs") then
			CC_Vars.messages = not CC_Vars.messages;
			
		elseif (args[1] == "reset") then
				CC_Reset_Data()
				
		elseif (args[1] == "defaults") then
				CC_Defaults()
			
		elseif (args[1] == "help") then
			CC_Message(CASHCOUNTER_MOVABLE);
			CC_Message(CASHCOUNTER_USAGE);
			CC_Message("options - "..CASHCOUNTER_OPTION);
			CC_Message("show - "..CASHCOUNTER_SHOW);
			CC_Message("hide - "..CASHCOUNTER_HIDE);
			CC_Message("toggle - "..CASHCOUNTER_TOGGLE);
			CC_Message("enable - "..CASHCOUNTER_ENABLE);
			CC_Message("disable - "..CASHCOUNTER_DISABLE);
			CC_Message("alpha <#> - "..CASHCOUNTER_ALPHA);
			CC_Message("expand up/down - "..CASHCOUNTER_ANCHOR);
			CC_Message("msgs - "..CASHCOUNTER_MESSAGES);
			CC_Message("reset - "..CASHCOUNTER_RESET);
			CC_Message("defaults - "..CASHCOUNTER_DEFAULTS);
		else
			CC_Message(CASHCOUNTER_NOCOMMAND);
		end
		CC_Ops_Update()
	end
end

function CC_Message(msg)
	if (CC_Vars.messages == true) then
		DEFAULT_CHAT_FRAME:AddMessage("[CashCounter]: "..msg);
	end
end

function CC_Visibility()
	if (CC_Vars.visible == true) then
		CC_Hide();
	else
		CC_Show();
	end
end

function CC_Hide()
	CC_Vars.visible = false;
	if (CC_Vars.expanded == true) then tmpvis = true;
	else tmpvis = false; end
	CC_Vars.expanded = false;
	CC_Title:Hide();
	CC_Frame:Hide();
	--CC_Message(CASHCOUNTER_HIDDEN);
end

function CC_Show()
	if (tmpvis == true) then
		CC_Vars.expanded = true;
		CC_Frame:Show();
	end
	CC_Vars.visible = true;
	CC_Title:Show();
	--CC_Message(CASHCOUNTER_VISIBLE);
end

function CC_Toggle()
	if (CC_Vars.enabled == true) then
		CC_Disable();
	else
		CC_Enable();
	end
end

function CC_Enable()
	CC_Vars.enabled = true;
	CC_Message(CASHCOUNTER_ENABLED);
end

function CC_Disable()
	CC_Vars.enabled = false;
	CC_Message(CASHCOUNTER_DISABLED);
end

function CC_Reset_Data() -- Reset Data
	CC_Vars.total = 0;
	CC_Vars.current = GetMoney();
	CC_Vars.gained = 0;
	CC_Vars.lost = 0;
	
	getCash();
	setStrings();
	setText();
end

function CC_Defaults() -- Default position, visibility, etc.
	CC_Vars.visible = true;
	CC_Vars.expanded = true;
	CC_Vars.above = false;
	CC_Vars.enabled = true;
	CC_Vars.alpha = 0.4;
	CC_Vars.messages = true;
	CC_Vars.topString = 1;
	CC_Vars.reset = false;
	CC_Vars.askreset = true;
	CC_Vars.combat = false;
	
	setAlpha(CC_Vars.alpha);
	CC_Title:ClearAllPoints();
	CC_Title:SetPoint("TOP","UIParent","TOP");
	
	CC_Title:Show();
	CC_Frame:Show();
	setAnchor();
	setText();
end

function CC_OnEvent(self, event, ...)
    if (event == "VARIABLES_LOADED") then
		if (CC_Vars.reset == false) then
			if (CC_Vars.askreset == true) then
				CC_Reset_Frame:Show();
			end
		elseif (CC_Vars.reset == true) then
			CC_Reset_Data();
		end
		
		if (CC_Vars.visible == false) then
			CC_Title:Hide();
		else
			CC_Title:Show();
		end
		if (CC_Vars.expanded == false) then
			CC_Frame:Hide();
		else
			CC_Frame:Show();
		end
		
		if (CC_Vars.bvis ~= nil) then
			CC_Vars.expanded = CC_Vars.bvis;
			CC_Vars.bvis = nil;
		end
		
		if (CC_Vars.banchor ~= nil) then
			if (CC_Vars.banchor == "BOTTOM") then CC_Vars.above = true;
			else CC_Vars.above = false; end
			CC_Vars.banchor = nil;
		end
		
		setText();
		setAlpha(CC_Vars.alpha);
		setAnchor();
		
	elseif (event == "PLAYER_ENTERING_WORLD") then
		CC_Vars.current = GetMoney();
		getCash();
		setStrings();
		setText();
		
    elseif (event == "PLAYER_MONEY") then
		if (CC_Vars.enabled == true) then
			getCash();
			setStrings();
			setText();
		else
			CC_Vars.current = GetMoney();
			CC_Strings.current = "Total: "..formatCash(CC_Vars.current);
			setText();
		end
	
	elseif (event == "PLAYER_REGEN_DISABLED") then
		if (CC_Vars.combat == true) then
			before_combat = CC_Vars.visible;
			CC_Hide();
		end
	
	elseif (event == "PLAYER_REGEN_ENABLED") then
		if (CC_Vars.combat == true) then
			if (before_combat == true) then
				CC_Show();
			end
		end
	end
end

function formatCash(amount)
	local gold = floor(abs(amount / 10000));
	local silver = floor(abs(mod(amount / 100, 100)));
	local copper = floor(abs(mod(amount,100)));
	return gold.."g "..silver.."s "..copper.."c";
end

function getCash()
	CC_Vars.total = CC_Vars.total + (GetMoney() - CC_Vars.current);
	if (GetMoney() < CC_Vars.current) then
		CC_Vars.lost = CC_Vars.lost + (CC_Vars.current - GetMoney());
	elseif (GetMoney() > CC_Vars.current) then
		CC_Vars.gained = CC_Vars.gained + (GetMoney() - CC_Vars.current);
	end
	CC_Vars.current = GetMoney();
end

function setText()
	if (CC_Vars.expanded == true) then
		CC_Frame_Cash:SetText(CC_Strings.current);
		CC_Frame_Total:SetText(CC_Strings.total);
		CC_Frame_Gained:SetText(CC_Strings.gained);
		CC_Frame_Lost:SetText(CC_Strings.lost);
		CC_Title_Text:SetText(CASHCOUNTER_TITLE);
	else
		if (CC_Vars.topString == 0) then
			CC_Title_Text:SetText(CC_Strings.current);
		elseif (CC_Vars.topString == 1) then
			CC_Title_Text:SetText(CC_Strings.total);
		elseif (CC_Vars.topString == 2) then
			CC_Title_Text:SetText(CC_Strings.gained);
		elseif (CC_Vars.topString == 3) then
			CC_Title_Text:SetText(CC_Strings.lost);
		end
	end
end

function setStrings()
	if (CC_Vars.total > 0) then
		CC_Strings.total = "Total Earned: "..formatCash(CC_Vars.total);
	elseif (CC_Vars.total < 0) then
		CC_Strings.total = "Total Lost: "..formatCash(CC_Vars.total);
	else
		CC_Strings.total = "Even spent/earned";
	end
	CC_Strings.gained = "Earned: "..formatCash(CC_Vars.gained);
	CC_Strings.lost = "Spent: "..formatCash(CC_Vars.lost);
	CC_Strings.current = "Total: "..formatCash(CC_Vars.current);
end

function setAnchor()
	CC_Frame:ClearAllPoints();
	if (CC_Vars.above == true) then
		CC_Frame:SetPoint("BOTTOM","CC_Title","TOP");
	else
		CC_Frame:SetPoint("TOP","CC_Title","BOTTOM");
	end
end

function setAlpha(alpha)
	CC_Title:SetBackdropColor(0,0,0,alpha);
	CC_Frame:SetBackdropColor(0,0,0,alpha);
	if (alpha == 0) then
		CC_Title:SetBackdropBorderColor(0,0,0,0);
		CC_Frame:SetBackdropBorderColor(0,0,0,0);
	else
		CC_Title:SetBackdropBorderColor(0,0,0,1);
		CC_Frame:SetBackdropBorderColor(0,0,0,1);
	end
end

function CC_OnEnter(self)
	GameTooltip_SetDefaultAnchor(GameTooltip, self);
	GameTooltip:SetText(CASHCOUNTER_TITLE);
	if (CC_Vars.enabled == false) then
		GameTooltip:AddLine(CASHCOUNTER_DISABLED);
	else
		GameTooltip:AddLine(CASHCOUNTER_ENABLED);
	end
	GameTooltip:AddLine(CASHCOUNTER_MOVE);
	GameTooltip:AddLine(CASHCOUNTER_EXPAND);
	if (CC_Vars.expanded == false) then GameTooltip:AddLine(CASHCOUNTER_SCROLL); end
	if (CC_Vars.messages == true) then
		GameTooltip:AddLine(CASHCOUNTER_OPTIONS);
	else
		GameTooltip:AddLine(CASHCOUNTER_MESSAGES_DISABLED);
	end
	GameTooltipTextLeft1:SetTextColor(1, 1, 1);
	GameTooltip:Show();
end

function CC_MouseDown(self, button)
	if (button == "LeftButton") then
		if (IsControlKeyDown()) then
			self:StartMoving();
			self.isMoving = true;
		elseif (CC_Vars.expanded == true) then
			CC_Frame:Hide();
			CC_Vars.expanded = false;
			setText();
		else
			CC_Frame:Show();
			CC_Vars.expanded = true;
			setText();
		end
	elseif (button == "RightButton") then
		if (CC_Options:IsShown()) then
			CC_Options:Hide();
		else
			CC_Options:Show();
		end
	end
end

function CC_MouseWheel(self, delta)
	if (delta > 0) then
		CC_Vars.topString = CC_Vars.topString - 1;
	else
		CC_Vars.topString = CC_Vars.topString + 1;
	end
	if (CC_Vars.topString >= 4) then
		CC_Vars.topString = 0;
	elseif (CC_Vars.topString <= -1) then
		CC_Vars.topString = 3;
	end
	setText();
end